//frame around all bars
float frame = 50;
int[] values = {
  2, 1, 10, 3, 6
};

void setup() {
  size(500, 500);
  textSize(20);
}

void draw() {

  plotValues(values);
}

void plotValues(int[] values) {
  //barWidth for a single bar and spacing
  float barWidth = (width - 2 * frame)/values.length;
  //spacing between bars (10 percent of barWidth or at least 2)
  float spacing = barWidth*0.1;
  if(spacing < 2){
    spacing = 2;
  }
  //calculate actual barWidth without spacing
  barWidth -= spacing;
  //height unit depending on the max value
  float barHeightUnit = (height - 2 * frame) / (1f*maxValue(values));
  float xPos = frame;
  for (int i : values) {
    //yPos calculated with the height unit
    float yPos = height-frame-barHeightUnit*i;
    //draw bar
    fill(255);
    rect(xPos, yPos, barWidth, (height - frame)-yPos);
    //draw label
    fill(0);
    text(i, xPos, yPos);
    xPos += barWidth+spacing;
  }
}

//finds max value in a float array
int maxValue(int[] values) {
  int result = 0;
  for (int i : values) {
    if (i > result) {
      result = i;
    }
  }
  return result;
}
